import java.util.ArrayList;
import java.util.Random;

import commandcenter.CommandCenter;
import enumerate.Action;
import enumerate.State;
import structs.FrameData;
import structs.GameData;
import structs.Key;
import gameInterface.AIInterface;

public class BloodMoon implements AIInterface {
	private Key _inputKey;
	private boolean _player;
	private FrameData _framedata;
	private CommandCenter _command;
	private GameData _gamedata;

	@Override
	public int initialize(GameData gameData, boolean playerNumber) {
		// TODO Auto-generated method stub
		_inputKey = new Key();
		_player = playerNumber;
		_framedata = new FrameData();
		_command = new CommandCenter();
		_gamedata = gameData;
		return 0;
	}

	@Override
	public void getInformation(FrameData frameData) {
		// TODO Auto-generated method stub
		_framedata = frameData;
		_command.setFrameData(_framedata, _player);
	}

	@Override
	public void processing() {
		// TODO Auto-generated method stub
		if (!_framedata.emptyFlag && _framedata.getRemainingTime() > 0) {
			int disX = _command.getDistanceX();// x轴距离
			int disY = _command.getDistanceY();// y轴距离
			State selfState = _command.getMyCharacter().getState();
			State oppState = _command.getEnemyCharacter().getState();
			if (disX < 100) {
				// x轴距离小于100
				if (disY > 0) {
					// 至少有一人在空中,防御
					CastSkill(GetGuardSkill());
				} else {
					// 2人高度一样或都在地面,在地面的可能性比2人高度一致几率大得多地多
					CastSkill(GetThrowSkill());
				}
			} else if (disX > 100 && disX <= 300) {
				// x轴距离在100到300
				if (disY > 0 && (selfState.equals(State.AIR))) {
					// 自己在空中,释放随机的技能,防止被针对
					CastSkill(GetRandomSkill());
				} else if (disY > 0 && (oppState.equals(State.AIR))) {
					// 对手在空中,释放远程技能
					CastSkill(GetProjectileSkill());
				} else {
					// 2人高度一样或都在地面,在地面的可能性比2人高度一致几率大得多地多,所以释放远程技能
					CastSkill(GetProjectileSkill());
				}
			} else {
				// 其他距离,释放技能以获取能量
				if (disY > 0 && (selfState.equals(State.AIR))) {
					// 自己在空中,释放防御,等待敌人靠近来释放技能
					CastSkill(GetGuardSkill());
				} else {
					// 对手在空中,释放远程技能
					CastSkill(GetProjectileSkill());
				}
			}
		}
	}

	@Override
	public Key input() {
		// TODO Auto-generated method stub
		return _inputKey;
	}

	@Override
	public void close() {
		// TODO Auto-generated method stub

	}

	private void CastSkill(Action _action) {
		if (!_command.getskillFlag()) {
			_inputKey.empty();
			_command.skillCancel();
			_command.commandCall(_action.toString());
		} else {
			_inputKey = _command.getSkillKey();
		}
	}

	private Action GetProjectileSkill() {
		Random _random = new Random();
		ArrayList<Action> list = new ArrayList<Action>();
		list.add(Action.STAND_D_DF_FA);
		list.add(Action.STAND_D_DF_FB);
		if (_command.getMyCharacter().getEnergy() >= 300) {
			list.add(Action.STAND_D_DF_FC);
		}
		return list.get(_random.nextInt(list.size()));
	}

	private Action GetCloseOppSkill() {
		Random _random = new Random();
		ArrayList<Action> list = new ArrayList<Action>();
		list.add(Action.STAND_D_DB_BA);
		list.add(Action.STAND_D_DB_BB);
		return list.get(_random.nextInt(list.size()));
	}

	private Action GetThrowSkill() {
		Random _random = new Random();
		ArrayList<Action> list = new ArrayList<Action>();
		list.add(Action.THROW_A);
		list.add(Action.THROW_B);
		return list.get(_random.nextInt(list.size()));
	}

	private Action GetRandomSkill() {
		Random _random = new Random();
		int index = _random.nextInt(Action.values().length - 1);
		return Action.values()[index];
	}

	private Action GetGuardSkill() {
		Action act;
		switch (_command.getMyCharacter().getState()) {
		case STAND:
			act = Action.STAND_GUARD;
			break;
		case CROUCH:
		case DOWN:
			act = Action.CROUCH_GUARD;
			break;
		case AIR:
			act = Action.AIR_GUARD;
			break;
		default:
			act = Action.STAND_GUARD;
			break;
		}
		return act;
	}
}
